#!/usr/bin/python

import sys
import koji
import time;

tag = 'f18'

def ts2hms(ts):
    d = ts / (24*3600);
    h = (ts / 3600) % 24;
    m = (ts/60) % 60;
    s = ts % 60;
    if d >= 1:
        return '%d+%02d:%02d:%02d' % (d, h, m, s);
    else:
        return '  %2d:%02d:%02d' % (h, m, s);

hostname = {}
def lookup_host(session, id):
    if not id in hostname:
        host = session.getHost(id)
        hostname[id] = host['name']
    return hostname[id]

def scan_koji(url):
    session = koji.ClientSession(url)

    builds = session.getLatestBuilds(tag=tag)
    print >> sys.stderr, "build count", len(builds)
    for build in builds:
        print >> sys.stderr, "build", build['name']

        if not build['task_id'] is None:
            ptask = session.getTaskInfo(build['task_id']);

            ctasks = session.getTaskChildren(build['task_id'])
            for ctask in ctasks:
                if ctask['method'] == 'buildArch' and 'completion_ts' in ctask and not ctask['completion_ts'] is None and not ctask['start_ts'] is None:
                    print ctask
                    host = lookup_host(session, ctask['host_id'])
                    elapsed = ctask['completion_ts'] - ctask['start_ts']
                    print ts2hms(elapsed), ctask['state'], ctask['arch'], build['package_name'], host, elapsed
            sys.stdout.flush()


#scan_koji('http://koji.fedoraproject.org/kojihub');
#scan_koji('http://arm.koji.fedoraproject.org/kojihub')
scan_koji(sys.argv[1]);
